# deploy

Deploy from a spec.

Does this by simply logging into each machine and do a `git pull origin`
followed by a `git rebase origin/<branch>`. Other strategies will follow, like
using rsync.

`before` and `after` actions can be triggered to, for example, clean up caches.

**This is very much a work in progress** to scratch an itch. Rubygems makes it
a very convenient way to share the scripts, even if it's not ready to be used en
masse ;-)


### Installation

    gem install deploy-cli


### Usage

    $ deploy
    Commands:
      deploy to [STAGE]      # Runs a deployment
      deploy help [COMMAND]  # Describe available commands or one specific command
      deploy version         # Show the current version


This script assume there's either a `deploy.yaml` file on the
current directory. If not you can pass it with `--file /path/to/deploy.yaml`.


### Sample yaml spec (deploy.yaml)

```yaml
template: &template
  user: deploy
  before:
    - echo "Started at `date`"
  after:
    - echo "Completed at `date`"

  notifications:
    email:
      - me@example.com
    slack:
      service: token-goes-here
      channel: "#deployments"



live:
  <<: *template
  path: /var/www/vhosts/example.com
  branch: master
  servers:
    - web-01.example.com
    - web-02.example.com


stage:
  <<: *template
  branch: dev
  path: /var/www/vhosts/stage.example.com
  servers:
    - stage-01.example.com

```
